// Hatrozzuk meg kt termszetes szm legnagyobb kzs osztjt s legkisebb kzs tbbszrst! 

#include <iostream>

using namespace std;

void euklidesz(int a, int b, int & lnko, int & lkkt){
// a s b egsz szmok lnko-jnak s lkkt-jnek kiszmtsa (ismtelt kivonsokkal)

	int x = a; // szksgnk lesz a s b eredeti rtkre az lkkt liszmtsakor
	int y = b; 
	
	while (a != b) 
      	if(a > b)
    		a = a - b;
	  	else
			b = b - a;
	lnko = a;
    lkkt = x * y / lnko;		
}

int lkktKulon(int a, int b){
// csak lkkt

  	int x = a;
  	int y = b;
	while(x != y)    
      	if(x > y){
		  	x = x - y;
         	a = a + b;
        }
      	else{
         	b = a + b;
         	y = y - x;
      	}
   	return (a + b) / 2;
}

int lnkoKulon(int a, int b){
// meghatrozza a s b legnagyobb kzs osztjt ismtelt osztsokkal

	int maradek;
	do{	 	 			 // ismtelt osztsokkal 
		maradek = a % b;
		a = b;
		b = maradek;
	} while(maradek != 0); 	   // kilpnk, amikor mar = 0 
	return a;
}

int main(){
	cout << " - lnko es lkkt kiszamitasa - " << endl;
	int a, b, lnko, lkkt;
	
	cout << "a = ";	cin >> a;
	cout << "b = ";	cin >> b;
	
	euklidesz(a, b, lnko, lkkt);
    
	cout << "Lnko = " << lnko << endl;
	cout << "Lkkt = " << lkkt << endl;
	cout << "Lkkt = " << lkktKulon(a, b) << endl;
	cout << "Lnko = " << lnkoKulon(a, b) << endl;
}
