// Döntsük el, hogy az adott szám palindromszám-e vagy sem!
// Egy szám palindrom, ha számjegyeit balról, illetve jobbról olvasva ugyanaz az értéke!

#include <iostream>

using namespace std;

bool palindrom(int szam){
// eldöntjük, hogy "szam" palindromszám-e vagy sem és térítjük a választ

	int masolat = szam;
	int ujszam = 0;
	int szamjegy;
	
	while(szam > 0){
		szamjegy = szam % 10;
		ujszam = (ujszam * 10) + szamjegy;
		szam = szam / 10;	
	}
	return ujszam == masolat;
}

bool palindromUj(int szam){
// nem fordítjuk meg a számot, hanem számjegyenként dolgozzuk fel
// első ?? utolsó, második ?? utolsóelőtti...

	bool pali = true;
	while(pali && szam > 9){
		int szj = szam % 10;
		szam = szam / 10;
		int szamMas = szam;
		int h = 1;
		while(szamMas > 9){
			szamMas = szamMas / 10;
			h = h * 10;
		}
		pali = szj == szamMas;
		szam = szam % h;
	}
	return pali;
}

int main(){
	cout << " - palindromszam - " << endl;
	int x;
	
	cout << "x = ";	cin >> x; 

	if( palindrom(x) )
		cout << x << " palindromszam" << endl;
	else
		cout << x << " NEM palindromszam!" << endl;

	if( palindromUj(x) )
		cout << x << " palindromszam" << endl;
	else
		cout << x << " NEM palindromszam!" << endl;
}
