/* Adott az n nem nulla természetes szám (0 < n ≤ 109). Döntsük el, hogy kettőhatvány-e! 
Ha az adott szám nem kettőhatvány, bontsuk kettőhatványok összegére!
Az alábbi megoldások a kettőhatvány eldöntésére hatékonyságuk növekvő sorrendjében következnek
*/

#include <iostream>

using namespace std;

int const maxDim = 100;

bool kettoHatvany(unsigned n, unsigned & m){
// generáljuk a kettőhatványokat, amíg ezek kisebbek, mint n 
// ha az utolsó kettőhatvány egyenlő n-nel, => n kettőhatvány

 	m = 1;
	while(m < n) 
		m *= 2; // amikor vége, m >= n
	return m == n;
}

void felbontas(unsigned n, int & k, unsigned tagok[]){

	unsigned m;
	k = 0;
	if(!kettoHatvany(n, m)){		
		while(n > 0){
			while(m > n)
				m /= 2; // visszafele
			k++;		
			tagok[k] = m;
			n -= m;
		}
	}
	else{
		k = 1;
		tagok[1] = n;
	}

}

void kiIras(unsigned n, int k, unsigned tagok[]){

	cout << n << " = ";  
	for(int i = 1; i <= k - 1; i++)
		cout << tagok[i] << " + ";
	cout << tagok[k] << endl;
}

int main(){	

	unsigned n;
	int k;

	unsigned tagok[maxDim];
	
	cout << "n = ";	cin >> n;

	felbontas(n, k, tagok);
	kiIras(n, k, tagok);
}
