// Generljunk prmszmokat (adott hatrig) Eratosztensz mdszervel!

#include <iostream>
#include <math.h>
using namespace std;

int const MAX = 100000;

void Eratosztenesz(int hatar, bool prim[]){
	
	for(int i = 2; i <= hatar; i++) 			// felrjuk a szmokat
		prim[i] = true;
	
	for(int i = 2; i * i <= hatar; i++){
		if(prim[i]){ 							// ha szm mg nincs kihzva
			int k = i * i;						// az i szm tbbszrse
			while(k <= hatar){
				prim[k] = false; 				// kihzzuk a tbbszrsket
				k += i;
			}
		}
	}
}

void kiIr(int hatar, bool prim[]){
// kirjuk a prmszmokat

int w = 0;
	for(int i = 2; i <= hatar; i++)	
		if(prim[i]) { 							// i prmszm
			cout << i << " ";
			w++;
		}
	cout << endl << "Osszesen " << w << " primszam." << endl;
}

int main(){
	
	bool prim[MAX];
	cout <<" - Eratoszthenesz szitaja - " << endl;
	int hatar;
	
	cout << "Hatar = ";	cin >> hatar;
	Eratosztenesz(hatar, prim);
	kiIr(hatar, prim);
}
